﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
' Command line setup
' ###########################################################################################################################
' This widget setup tool is a part of One Click Around application : 	http://oneclickaround.esy.es/
' One Click Around forum : 		http://oneclickaround.esy.es/Forum

' Copyright (C) 2014 by Didier Terrien, France
' ###########################################################################################################################

Sub Class_Globals
	Private fx As JFX
	Private Calling_module As Object, Event_name As String 
	Public Style As String 
	' Option types
	Public C_Label_type As Int = 0
	Public C_Text_type As Int = 1
	Public C_Combobox_type As Int = 2
	Public C_Folder_type As Int = 3
	Public C_Folder_type As Int = 4
	Public C_File_type As Int = 5
	
	Private C_Panel_width As Int = 600
	Private C_Panel_views_offset As Int = 25
	Private C_Field_left_position As Int = 150

	Private Owner As Pane 
	Private Panel As Pane
	Private Title As Label 
	Private B_Ok, B_Close As Button 
	Private View_position As Int 
	Private Fields_list As List 
	Private Fields_type_list As List 
	Private Prefixes_list As List 
	Private Output_command_line As String 
End Sub

Public Sub Initialize (Calling_module_v As Object, Event_name_v As String, Owner_v As Pane, Title_text As String) 
	Calling_module = Calling_module_v 
	Event_name = Event_name_v 
	Owner = Owner_v
	Title.Initialize ("")
	Title.Text = Title_text
	B_Ok.Initialize ("B_Ok")
	B_Close.Initialize ("B_Close")
	Fields_list.Initialize 
	Fields_type_list.Initialize 
	Prefixes_list.Initialize
End Sub

' Add an option to setup window
' Name : Name of the displayed option  
' Option_type : field type (use option types constants)
' Option_value : default value of the option
' Option_list : list for combobox type (null for other fields)
' Sub_owner_v : calling module for call back subs
' Event_name_v : event name for call back subs (doesn't work yet !!!!!)
' Prefix : prefix which will be added to the value into the command line
Public Sub Add_option (Name As String, Option_type As Int, Option_value As Object, Option_list As Object, Sub_owner_v As Object, Event_name_v As String, Prefix As String)
	If Panel.IsInitialized = False Then Initialize_panel
	' Label name
	Dim Name_label As Label 
	Name_label.Initialize ("")
	Name_label.Text = Name & " : "
	Panel.AddNode (Name_label, 15, View_position, C_Panel_width /4, 20)
	' Field type
	Select Case Option_type
	Case C_Label_type									' Label field
		Dim Label_field As Label
		Label_field.Initialize ("Label_field")
		Dim Text_value As String = Option_value
		Label_field.Text = Text_value
		Panel.AddNode (Label_field, C_Field_left_position, View_position, C_Panel_width *3 /4 -30, 20)
		Fields_list.Add (Label_field)
		Fields_type_list.Add (C_Label_type) 
	Case C_Text_type									' Text field
		Dim Text_field As TextField  
		Text_field.Initialize ("Text_field")
		Dim Text_value As String = Option_value
		Text_field.Text = Text_value
		Panel.AddNode (Text_field, C_Field_left_position, View_position, C_Panel_width *3 /4 -30, 20)
		Fields_list.Add (Text_field)
		Fields_type_list.Add (C_Text_type) 
	Case C_Combobox_type								' Combo box
		Dim Combo_box As ComboBox 
		Combo_box.Initialize ("Combo_field")
		Dim Combo_list() As String = Option_list
		For i = 0 To Combo_list.Length - 1
			Combo_box.Items.Add (Combo_list(i))
			If Combo_list(i) = Option_value Then
				Combo_box.Value = Option_value
			End If
		Next 
		Panel.AddNode (Combo_box, C_Field_left_position, View_position, C_Panel_width *3 /4 -30, 20)
		Fields_list.Add (Combo_box)
		Fields_type_list.Add (C_Combobox_type) 
	Case C_Folder_type									' Folder field
		Dim Text_field As TextField  
		Text_field.Initialize ("Text_field")
		Dim Text_value As String = Option_value
		Text_field.Text = Text_value
		Panel.AddNode (Text_field, C_Field_left_position, View_position, C_Panel_width *3 /4 -30, 20)
		Fields_list.Add (Text_field)
		Fields_type_list.Add (C_Folder_type) 
		Dim B_Folder_chooser As Button 
		B_Folder_chooser.Initialize ("B_Folder_chooser")
		B_Folder_chooser.Text = "..."
		B_Folder_chooser.Tag = Fields_list.Size - 1
		Panel.AddNode (B_Folder_chooser, C_Panel_width -25, View_position, 20, 20)
	Case C_File_type									' File field
		Dim Text_field As TextField  
		Text_field.Initialize ("Text_field")
		Dim Text_value As String = Option_value
		Text_field.Text = Text_value
		Panel.AddNode (Text_field, C_Field_left_position, View_position, C_Panel_width *3 /4 -30, 20)
		Fields_list.Add (Text_field)
		Fields_type_list.Add (C_File_type) 
		Dim B_File_chooser As Button 
		B_File_chooser.Initialize ("B_File_chooser")
		B_File_chooser.Text = "..."
		B_File_chooser.Tag = Fields_list.Size - 1
		Panel.AddNode (B_File_chooser, C_Panel_width -25, View_position, 20, 20)
	End Select	
	Prefixes_list.Add (Prefix)
	View_position = View_position + C_Panel_views_offset
End Sub

Public Sub Show (Left As Double, Top As Double)
	Owner.AddNode (Panel, Left, Top, C_Panel_width, View_position + 20)
End Sub

Public Sub Close
	If Panel.IsInitialized Then
		Panel.Visible = False
		Panel.RemoveNodeFromParent 
		Panel.Initialize ("")
		Panel = Null
	End If
End Sub

Private Sub Combo_field_ValueChanged (Value As Object)
	If SubExists(Calling_module, Event_name & "_Combo_value_changed") Then
		CallSub2(Calling_module, Event_name & "_Combo_value_changed", Value)
	End If
End Sub

Private Sub B_File_chooser_MouseClicked (EventData As MouseEvent)
	Dim Sender_button As Button = Sender
	Dim Text_field As TextField = Fields_list.Get (Sender_button.Tag) 
	Dim File_choosed As String = Utils.File_choose ("Open", "Looking for file", Text_field.Text, File.GetFileParent (Text_field.Text), "All files", Array As String("*.*"))
	If File_choosed.Trim.Length > 0 Then
		Text_field.Text = File_choosed
	End If
End Sub

Private Sub B_Folder_chooser_MouseClicked (EventData As MouseEvent)
	Dim Sender_button As Button = Sender
	Dim Text_field As TextField = Fields_list.Get (Sender_button.Tag) 
	Dim Folder_choosed As String = Utils.Folder_choose ("Looking for folder", Text_field.Text)
	If Folder_choosed.Trim.Length > 0 Then
		Text_field.Text = Folder_choosed
	End If
End Sub

Private Sub B_Ok_MouseClicked (EventData As MouseEvent)
	Output_command_line  = ""
	For i = 0 To Fields_list.Size - 1
		If i > 0 Then Output_command_line = Output_command_line & "  ,  "
		Output_command_line = Output_command_line & Prefixes_list.Get (i)
		Select Case Fields_type_list.Get (i)
		Case C_Label_type
			Dim Label_field As Label = Fields_list.Get (i) 
			Output_command_line = Output_command_line & Label_field.Text 
		Case C_Text_type 
			Dim Text_field As TextField = Fields_list.Get (i) 
			Output_command_line = Output_command_line & Text_field.Text
		Case C_Combobox_type
			Dim Combo_box As ComboBox = Fields_list.Get (i)
			Output_command_line = Output_command_line & Combo_box.Value 
		Case C_Folder_type 
			Dim Text_field As TextField = Fields_list.Get (i) 
			Output_command_line = Output_command_line & Text_field.Text
		Case C_File_type
			Dim Text_field As TextField = Fields_list.Get (i) 
			Output_command_line = Output_command_line & Text_field.Text
		End Select
	Next
	Panel.Visible = False
	Panel.RemoveNodeFromParent 
	Panel.Initialize ("")
	If SubExists (Calling_module, Event_name & "_Setup_ok") Then
		CallSub2 (Calling_module, Event_name & "_Setup_ok", Output_command_line)
	End If
End Sub

Private Sub B_Close_MouseClicked (EventData As MouseEvent)
	Close
	If SubExists(Calling_module, Event_name & "_Setup_cancel") Then
		CallSub (Calling_module, Event_name & "_Setup_cancel")
	End If
End Sub

Private Sub	Initialize_panel
	If Panel.IsInitialized = False Then
		Panel.Initialize ("")
		Panel.Style = Utils.Init_default_style (Style)
		Panel.AddNode (Title, 10, 5, C_Panel_width - 100, 10)
		B_Close.Text = "X"
		B_Close.TooltipText = "Cancel parameters modification"
		Panel.AddNode (B_Close, C_Panel_width - 25, 5, 10, 20)
		B_Ok.Text = "Ok"
		B_Ok.TooltipText = "Validate parameters"
		Panel.AddNode (B_Ok, C_Panel_width - 75, 5, 40, 20)
		View_position = 30
	End If
End Sub
